%%% goal kick module for ukola team
%%% Copyright (C) Aug 17 1998 Oliver Obst

%%% $Id: oo_goal_kick.pl,v 1.1 1998/11/06 13:30:11 frvit Exp $

%% This program is free software; you can redistribute it and/or
%% modify it under the terms of the GNU General Public License
%% as published by the Free Software Foundation; either version 2
%% of the License, or (at your option) any later version.

oo_goal_kick :-
	view(Width),
	view(wide),
	await_refresh,
	goal_side(GS),
	gk_get_dir(GS, Dir),
	goal(GS, GDist, _GDir, _GX, _GY, _GW),
	(GDist > 10 ->
	    (GK_Dist is GDist + 5,
	     kick_to(GK_Dist, Dir));
	    kick(100,Dir)),
	view(Width).

gk_get_dir(l, Dir) :-
	goal(l, _, _, GX, GY, GW),
	YL is GY + GW/2,
	YR is GY - GW/2,
	absangle(GX, YL, Phi1), setval(phi1, Phi1),
	absangle(GX, YR, Phi2), setval(phi2, Phi2),
	findall(X, gk_goalie_dir(X), L),
	gk_minandmax(L, Min, Max),
	(Min - Phi1 > Phi2 - Max ->
	    (Y is GY + GW/2 - 0.5,
	     absangle(GX, Y, Dir));
	    Y is GY - GW/2 + 0.5,
	    absangle(GX, Y, Dir)).

gk_get_dir(r, Dir) :-
	goal(r, _, _, GX, GY, GW),
	YL is GY - GW/2,
	YR is GY + GW/2,
	absangle(GX, YL, Phi1), setval(phi1, Phi1),
	absangle(GX, YR, Phi2), setval(phi2, Phi2),
	write("Links: "), writeln(Phi1),
	write("Rechts:"), writeln(Phi2),
	findall(X, gk_goalie_dir(X), L),
	write("Liste: "),
	writeln(L),
	gk_minandmax(L, Min, Max),
	(Min - Phi1 > Phi2 - Max ->
	    (Y is GY - GW/2 + 1,
	     absangle(GX, Y, Dir),
	     write("Nach links: "),
	     writeln(Dir));
	    Y is GY + GW/2 - 1,
	    absangle(GX, Y, Dir),
	    write("Nach rechts: "),
	    writeln(Dir)).

gk_get_dir(GS, Dir) :-
	writeln("Wohl niemand im Tor, wie?"),
	goal(GS, _Dist, Dir, _, _, _).


gk_goalie_dir(Dir) :-
	opponent(_Nr, _Dist, Dir, _DDist, _DDir, _X, _Y),
	getval(phi1, Phi1),
	getval(phi2, Phi2),
	Phi1 < Dir,
	Dir < Phi2.

gk_goalie_dir(Dir) :-
	player(_Nr, _Dist, Dir, _DDist, _DDir, _X, _Y),
	getval(phi1, Phi1),
	getval(phi2, Phi2),
	Phi1 < Dir,
	Dir < Phi2.

gk_minandmax([E], E, E).

gk_minandmax([H|T], Minimum, Maximum) :-
	gk_minandmax(T, Min, Max),
	min(Min, H, Minimum),
	max(Max, H, Maximum).

