:- ensure_loaded("oo_goal_kick.pl").
:- ensure_loaded("oo_chase_ball.pl").

start_pos(1, -40, 0).

start_pos(2, -35, -20).
start_pos(3, -35, 0).
start_pos(4, -35, 20).

start_pos(5, -20, -25).
start_pos(6, -20, -10).
start_pos(7, -20, 10).
start_pos(8, -20, 25).

start_pos(9, -5, -12).
start_pos(10, -1, -17).

start_pos(11, -1, 0) :-
	myside(l).
start_pos(11, -10, 0).

home_pos(1, -40, 0) :-
	myside(l).
home_pos(1, 40, 0).

home_pos(2, -35, -20) :-
	myside(l).
home_pos(2, 35, -20).

home_pos(3, -35, 0) :-
	myside(l).
home_pos(3, 35, 0).

home_pos(4, -35, 20) :-
	myside(l).
home_pos(4, 35, 20).

home_pos(5, -10, -22) :-
	myside(l).
home_pos(5, 10, -22).

home_pos(6, -10, -8) :-
	myside(l).
home_pos(6, 10, -8).

home_pos(7, -10, 8) :-
	myside(l).
home_pos(7, 10, 8).

home_pos(8, -10, 22) :-
	myside(l).
home_pos(8, 10, 22).

home_pos(9, 22, -25) :-
	myside(l).
home_pos(9, -22, -25).
home_pos(10, 20, 23) :-
	myside(l).
home_pos(10, -20, 23).
home_pos(11, 22, 0) :-
	myside(l).
home_pos(11, -22, 0).


%% move_to improved
my_moveto(X,Y) :-
	myside(l),
	my_moveto(X, Y, 0, 1).

my_moveto(X,Y) :-
	myside(r),
	my_moveto(X, Y, 0, -1).



my_moveto(X0,Y0,_,Sgn) :-
	moveto(X0,Y0),
	await_refresh,
	self(X1,Y1,_),
	X is Sgn * X0 - X1,
	Y is Sgn * Y0 - Y1,
	(X1 < -9000; 2 > abs(X)),
	(Y1 < -9000; 2 > abs(Y)), !.

my_moveto(X0,Y0,Count,Sgn) :-
	Count < 3,
	Next is Count + 1,
	my_moveto(X0,Y0,Next,Sgn).

my_moveto(_,_,_,_).


%% my_kick_to

my_kick_to(Dist, Dir) :-
	Dir > -90,
	Dir =< 90,
	kick_to(Dist, Dir), !.

my_kick_to(Dist, Dir) :-
	Dir =< 180,
	Dir > -180,
	Dir1 is sgn(Dir) * 45,
	Dir2 is sgn(Dir) * 90,
	kick_to(1, Dir1),
	kick_to(1, Dir2),
	refresh,
	kick_to(Dist, Dir), !.

my_kick_to(Dist, Dir) :-
	Diff is sgn(Dir) * 360,
	Dir1 is Dir - Diff,
	my_kick_to(Dist, Dir1).
	

%% get goal position
my_goal(Side, Dist, Dir, X, Y, W) :-
	await_refresh,
	goal(Side, Dist, Dir, X, Y, W),
	Dist > -9000,
	Dir > -9000, !.

my_goal(Side, Dist, Dir, X, Y, W) :-
	view(wide),
	wait_for_robo,
	await_refresh,
	goal(Side, Dist, Dir, X, Y, W),
	view(normal).

%% get ball position
my_ball(Dist, Dir, DDist, DDir, X, Y) :-
	await_refresh,
	ball(Dist, Dir, DDist, DDir, X, Y),
	Dist > -9000,
	Dir > -9000, !.

my_ball(Dist, Dir, DDist, DDir, X, Y) :-
	view(wide),
	wait_for_robo,
	await_refresh,
	ball(Dist, Dir, DDist, DDir, X, Y),
	Dist > -9000,
	Dir > -9000,
	view(normal), !.

my_ball(Dist, Dir, DDist, DDir, X, Y) :-
	turn(180),
	wait_for_robo,
	await_refresh,
	ball(Dist, Dir, DDist, DDir, X, Y),
	Dist > -9000,
	Dir > -9000,
	view(normal), !.
	
my_ball(_, _, _, _, _, _) :-
	view(normal),
	fail.


my_self(X,Y,Dir) :-
	refresh,
	self(X,Y,Dir),
	X > -9000,
	Y > -9000, !.

my_self(X,Y,Dir) :-
	view(wide),
	self(X,Y,Dir),
	X > -9000,
	Y > -9000,	
	view(normal), !.

my_self(X,Y,Dir) :-
	turn(180),
	await_refresh,
	self(X,Y,D),
	turn(180),
	Dir is D - 180,
	self(X,Y,Dir),
	view(normal).


%% in Ballrichtung drehen
turn_to_ball :-
	my_ball(_Dist,Dir,_DDist,_DDir,_X,_Y),
	abs(Dir,AbsDir),
	AbsDir > 1,
	turn(Dir).

turn_to_ball.



start :-
	start(oliver).

start(Team) :-
	start(Team, "localhost").

start(Team,Host) :-
	init(player,Team,Host),
	await_refresh,
	vor_anpfiff,
	wait_for_robo,
	await_refresh.

vor_anpfiff :-
	(referee(undefined); referee(before_kick_off);
	 referee(goal_l_); referee(goal_r_)),
	uniformnumber(NR),
	start_pos(NR, X, Y),!,
	my_moveto(X,Y), !.

vor_anpfiff.


play :-
	refresh,
	referee(Message),
	write("The referee sais: "),
	writeln(Message),
	game(Message),
	not referee(time_over),
	play.

play.


game(play_on) :-
	my_ball(Dist,Dir,_DDist,_DDir,_X,_Y),
	Dist > 30,
	home_or_chase(Dist, Dir, 35).

game(play_on) :-	
	ball(Dist, Dir, _DDist, _DDir, _X, _Y),
	Dist > 10,
	home_or_chase(Dist, Dir, 90).

game(play_on) :-
	ball(Dist, Dir, _DDist, _DDir, _X, _Y),
	Dist > 1,
	home_or_chase(Dist, Dir, 35).
	
game(play_on) :-
	pass_or_dribble.
	

game(Message) :-
	(Message = before_kick_off;
	 Message = goal_l;
	 Message = goal_r;
	 Message = undefined),
	uniformnumber(NR), 
	start_pos(NR, X, Y),!,
	my_moveto(X,Y), !,
	while_message_do(Message, turn_to_ball).

game(kick_off_l) :-
	myside(l),
	game(play_on).

game(kick_off_r) :-
	myside(r),
	game(play_on).


game(_).


%% Aktion "Do" solange ausfuehren, bis sich die Schiedrichter-Nachricht aendert
while_message_do(Message, Do) :-
	refresh,
	referee(Message),
	Do,
	while_message_do(Message, Do).

while_message_do(_,_).


home_or_chase(BallDist, BallDir) :-
	home_or_chase(BallDist, BallDir, 90).

home_or_chase(BallDist, BallDir, Speed) :-
	oo_chase_ball ->
	(turn(BallDir),
	 dash(Speed),
	 await_refresh);
	go_home.

home_or_chase(_,_,_).


go_home :-
	go_home(8).

go_home(0).

go_home(N) :-
	writeln("going home"),
	uniformnumber(Nr),
	home_pos(Nr, X, Y),
	refresh,
	dist(X,Y, Dist), Dist > 1,
	absangle(X,Y, Angle),
	my_self(_,_,Heading),
	TurnAngle is Angle - Heading,
	turn(TurnAngle),
	dash(10),
	wait_for_robo,
	M is N - 1,
	go_home(M).

go_home(_).


pass_or_dribble :-
	pass; dribble.
	

pass :-
	partner(Nr, PDist, PDir, _DDist, _DDir, PX, _PY),
	my_self(X, _Y, _Dir),
	PDist < 35,
	PX > X,
	write("Pass zu "), writeln(Nr),
	KickDist is PDist + 5,
	my_kick_to(KickDist, PDir).

dribble :-
	my_ball(_Dist, Dir, _DDist, _DDir, _X, _Y),
	goal_side(S),
	my_goal(S, GDist, GDir, _, _, _),
	GDist > 25,
	writeln("dribble"),
	refresh,
	my_kick_to(5, GDir).

dribble :-
	writeln("Goal Kick"),
	oo_goal_kick.
