/* -*- mode: c++ -*-
   
   this file is part of the robolog libraries
   Copyright (C) Sep 01 1998 Oliver Obst
   array to store information about messages
   $Id: msgarray.h,v 1.2 1999/05/05 14:12:57 frvit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _MSGARRAY_H
#define _MSGARRAY_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "constants.h"
#include "msginfo.h"

class MsgArray
{
public:
        MsgArray(int msize=MaxMessage);
        MsgArray(const MsgArray &ma);
        virtual ~MsgArray();

        inline int      get_size() const { return size; }
        inline int      get_entries() const { return entries; }
        inline int      get_refmsgs() const { return refmsgs; }
        inline int      get_ownmsgs() const { return ownmsgs; }
        inline int      get_othermsgs() const
                { return entries - refmsgs - ownmsgs; }
        
        bool    add_message(MsgInfo &m);
        void    clear();

        MsgInfo& referee(int i) const;
        MsgInfo& self(int i) const;
        MsgInfo& others(int i) const;
        
        MsgInfo& operator[](int i) const;
        MsgArray& operator=(const MsgArray &ma);

#if 0
        friend ostream& operator <<(ostream &os, MsgArray &ma);
#endif
        
private:
        MsgInfo *messages;
        MsgInfo *emsg;
        int     size;
        int     entries;
        int     refmsgs;
        int     ownmsgs;
};
        
#endif
