/* -*- mode: c++ -*-
   this file is part of the robolog libraries
   read soccer server parameter
   Copyright (C) Apr 06 1999 Oliver Obst
   $Id: parameter.h,v 1.1 1999/05/05 15:02:31 frvit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _PARAMETER_H
#define _PARAMETER_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

// #include "constants.h"
const int FilenameLen = 150;
const int HostnameLen = 50;

class Parameter
{
public:
        Parameter();

        void read_options(const char *filename, int verbose=0);

        // Server params
	double  SP_pitch_length;
	double	SP_pitch_width;
	double	SP_pitch_margin;
	double	SP_penalty_area_length;
	double	SP_penalty_area_width;
	double	SP_goal_area_length;
	double	SP_goal_area_width;
	double	SP_penalty_spot_dist;
	double	SP_corner_arc_r;
	double	SP_free_kick_buffer;
      	int	SP_after_goal_wait;
        double  SP_feel_distance;
      	int	SP_num_lines;
	int	SP_num_markers;
	double	SP_unum_far_length;
	double	SP_unum_too_far_length;
	double	SP_team_far_length;
	double	SP_team_too_far_length;

	double	SP_version;
	int	SP_team_size;
	int	SP_half;
        char    SP_host[HostnameLen];

        // server.conf starts here
	double	SP_goal_width;
        
	double	SP_player_size;	
	double	SP_player_decay;    	
	double	SP_player_rand;	
	double	SP_player_weight;	
	double	SP_player_speed_max;
        
	double	SP_stamina_max;
	double	SP_stamina_inc_max;
	double	SP_recover_dec_thr;
	double	SP_recover_dec;
	double	SP_recover_min;
        
	double	SP_effort_dec_thr;
	double	SP_effort_dec;
	double	SP_effort_inc_thr;
	double	SP_effort_inc;
	double	SP_effort_min;

	int	SP_hear_max;
	int	SP_hear_inc;
	int	SP_hear_decay;        

	double  SP_inertia_moment;

        int     SP_sense_body_step;

	double	SP_catchable_area_l;
	double	SP_catchable_area_w;
	double	SP_catch_probability;
	int	SP_catch_ban_cycle;
        
	double	SP_ball_size;		
	double	SP_ball_decay;	
	double	SP_ball_rand;		
	double	SP_ball_weight;
	double	SP_ball_speed_max;

	double	SP_wind_force;
        double	SP_wind_dir;        
	double	SP_wind_rand;
        bool    SP_wind_none;
        bool    SP_wind_random;

	double	SP_kickable_margin;
        double  SP_control_radius;
        double  SP_ckick_margin;
	double	SP_dash_power_rate;
	double	SP_kick_power_rate;	

        double	SP_visible_angle;
	double	SP_visible_distance;    // 3
	double	SP_audio_cut_dist;

        double  SP_quantize_step;
        double  SP_quantize_step_l;        

	double	SP_maxpower;		
	double	SP_minpower;
	double	SP_maxmoment;		
	double	SP_minmoment;
	double	SP_maxneckang;
	double	SP_minneckang;

        int     SP_port;
      	int     SP_coach_port;
        int     SP_olcoach_port;
        
        int     SP_coach_cnt_max;
        int     SP_coach_msg_size;
        int     SP_send_vi_step;

	int	SP_simulator_step;
	int	SP_send_step;
	int	SP_recv_step;
        int     SP_half_time;        
	int	SP_say_msg_size;

	bool	SP_use_offside;
	double  SP_offside_active_area_size;
	bool	SP_forbid_kick_off_offside;

	bool	SP_verbose;
        int     SP_record_version;
        bool    SP_record_log;
        bool    SP_send_log;
        char    SP_log_file[FilenameLen];
        char    SP_record[FilenameLen];
        char    SP_replay[FilenameLen];
        
	bool	SP_coach;
	bool	SP_coach_w_referee;
        bool    SP_old_coach_hear;
        // server.conf ends here

        double	SP_kickable_area;

private:
        static const int optsize = 150;
        
        enum InputType { V_INT, V_DOUBLE, V_BOOL, V_STRING, V_ONOFF, V_NONE };

        struct option_t 
        {
                char name[32];
                void *vptr;
                InputType vsize;
        };
        
        option_t options[optsize];
};

#endif /* _PARAMETER_H */

