/* -*- mode: c++ -*-
   this file is part of the robolog libraries
   write error messages
   Copyright (C) Apr 16 1999 Oliver Obst
   $Id: robobug.h,v 1.1 1999/05/05 15:02:36 frvit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ROBOBUG_H
#define _ROBOBUG_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdio.h>

/**
 * The idea for this file was stolen from kdebug.h, a part of the KDE
 * libraries, which is Copyright by Matthias Kalle Dalheimer <kalle@kde.org>
 * and released under LGPL.
 */
#ifndef _ROBOLOG_H
enum DebugLevel { ROBOBUG_INFO = 1,
                  ROBOBUG_WARN = 2,
                  ROBOBUG_ERROR = 4,
                  ROBOBUG_FATAL = 8 };
#endif

void robobug(DebugLevel level, unsigned short area, const char *fmt, ...);
void bugfile(FILE *f, unsigned char levels);
void bugfile(const char *filename, unsigned char levels);
void robobug_area(unsigned short a1);
void delete_bugareas();

#ifndef NDEBUG
#define ROBOBUG(Level,Area,String) robobug(Level,Area,String);
#define ROBOBUG1(Level,Area,String,Par1) robobug(Level,Area,String,Par1);
#define ROBOBUG2(Level,Area,String,Par1,Par2) robobug(Level,Area,String,Par1,Par2);
#define ROBOBUG3(Level,Area,String,Par1,Par2,Par3) robobug(Level,Area,String,Par1,Par2,Par3);
#define ROBOBUG4(Level,Area,String,Par1,Par2,Par3,Par4) robobug(Level,Area,String,Par1,Par2,Par3,Par4);
#define ROBOBUG5(Level,Area,String,Par1,Par2,Par3,Par4,Par5) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5);
#define ROBOBUG6(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6);
#define ROBOBUG7(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7);
#define ROBOBUG8(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8);
#define ROBOBUG9(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8,Par9) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8,Par9);
#define RASSERT(Cond,Level,Area,String) { if (!Cond) robobug(Level,Area,String); }
#define RASSERT1(Cond,Level,Area,String,Par1) { if (!Cond) robobug(Level,Area,String,Par1); }
#define RASSERT2(Cond,Level,Area,String,Par1,Par2) { if (!Cond) robobug(Level,Area,String,Par1,Par2); }
#define RASSERT3(Cond,Level,Area,String,Par1,Par2,Par3) { if (!Cond) robobug(Level,Area,String,Par1,Par2,Par3); }
#define RASSERT4(Cond,Level,Area,String,Par1,Par2,Par3,Par4) { if (!Cond) robobug(Level,Area,String,Par1,Par2,Par3,Par4); }
#define RASSERT5(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5) { if (!Cond) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5); }
#define RASSERT6(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6) { if (!Cond) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6); }
#define RASSERT7(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7) { if (!Cond) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7); }
#define RASSERT8(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8) { if (!Cond) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8); }
#define RASSERT9(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8,Par9) { if (!Cond) robobug(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8,Par9); }
#else
#define ROBOBUG(Level,Area,String)
#define ROBOBUG1(Level,Area,String,Par1)
#define ROBOBUG2(Level,Area,String,Par1,Par2)
#define ROBOBUG3(Level,Area,String,Par1,Par2,Par3)
#define ROBOBUG4(Level,Area,String,Par1,Par2,Par3,Par4)
#define ROBOBUG5(Level,Area,String,Par1,Par2,Par3,Par4,Par5)
#define ROBOBUG6(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6)
#define ROBOBUG7(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7)
#define ROBOBUG8(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8)
#define ROBOBUG9(Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8,Par9)
#define RASSERT(Cond,Level,Area,String)
#define RASSERT1(Cond,Level,Area,String,Par1)
#define RASSERT2(Cond,Level,Area,String,Par1,Par2)
#define RASSERT3(Cond,Level,Area,String,Par1,Par2,Par3)
#define RASSERT4(Cond,Level,Area,String,Par1,Par2,Par3,Par4)
#define RASSERT5(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5)
#define RASSERT6(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6)
#define RASSERT7(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7)
#define RASSERT8(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8)
#define RASSERT9(Cond,Level,Area,String,Par1,Par2,Par3,Par4,Par5,Par6,Par7,Par8,Par9)
#endif

#endif /* _ROBOBUG_H */
