%%% Robolog bootfile for ECLiPSe prolog
%%% Copyright (C) Mar 03 1998 Oliver Obst

%%% $Id: robolog-b.pl,v 1.5 1999/05/05 14:57:33 frvit Exp $

%% This program is free software; you can redistribute it and/or
%% modify it under the terms of the GNU General Public License
%% as published by the Free Software Foundation; either version 2
%% of the License, or (at your option) any later version.


:-      % set shell variable "ROBOLOG" accordingly
	getenv("ROBOLOG", EPREFIX),
	concat_strings(EPREFIX, "/lib/ec_robolog.so", ROBOLOG),	
        current_interrupt(IRQ, alrm),
 	set_interrupt_handler(IRQ, default/0),
	load(ROBOLOG),
	external(absangle/3, "p_absangle"),
	external(atan2/3, "p_atan2"),
	external(await_refresh/0, "p_await_refresh"),
	external(b_ball/3, "p_ball_dep"),
	external(b_ball/4, "p_ball"),
	b_external(b_flag/4, "p_flag"),
	b_external(b_goal/3, "p_goal_dep"),
	b_external(b_goal/4, "p_goal"),
	b_external(b_line/4, "p_line"),
	b_external(b_opponent/3, "p_opponent_dep"),
	b_external(b_opponent/4, "p_opponent"),
	b_external(b_partner/3, "p_partner_dep"),
	b_external(b_partner/4, "p_partner"),
	b_external(b_player/3, "p_player_dep"),
	b_external(b_player/4, "p_player"), 
	external(catch/1, "p_catch"),
	external(close_log/0, "p_close_log"),
	external(close_audiolog/0, "p_close_audiolog"),
	external(closest_point_inside/8, "p_closest_point_inside"),
	external(dash/1, "p_dash"),
	external(dashs/1, "p_dashs"),
	external(deg2rad/2, "p_deg2rad"),
	external(dequeue/0, "p_dequeue"),
	external(dir_quality/2, "p_dir_quality"),
	external(dist/3, "p_dist"),
	external(dist_point_line/7, "p_dist_point_line"),
	external(dist_quality/2, "p_dist_quality"),
	external(distance_to_edge/7, "p_distance_to_edge"),
	external(effort/1, "p_effort"),
	external(flag/2, "p_n_flag"),
	external(goal/2, "p_n_goal"),
	external(goal_side/1, "p_goal_side"),
	external(goalie/0, "p_is_goalie"),
	external(goalie/2, "p_goalie_nr"),
	external(goals/3, "p_goals"),
	external(init_goalie/4, "p_init_goalie"),
	external(init_player/4, "p_init_player"),
	external(kick/2, "p_kick"),
	external(kick_to/2, "p_kick2"),
	external(line/2, "p_n_line"),
	external(line_angle/5, "p_line_angle"),
	external(message/3, "p_n_message"),
	external(message/5, "p_message"),
	external(moveto/2, "p_moveto"),
	external(msgidx/1, "p_msgidx"),
	external(myside/1, "p_myside"),
	external(nearest_edge/8, "p_nearest_edge"),
	external(neck/2, "p_neck"),
	external(nextmsgidx/1, "p_nextmsgidx"),
	external(open_log/3, "p_open_log"),
	external(open_audiolog/3, "p_open_audiolog"),
	external(opponent/2, "p_n_opponent"),
	external(opposite/2, "p_opposite"),
	external(partner/2, "p_n_partner"),
	external(player/2, "p_n_player"),
	external(point_in_box/6, "p_point_in_box"),
	external(point_on_line/6, "p_point_on_line"),
	external(point_between/6, "p_point_between"),
	external(pred_quality/2, "p_pred_quality"),
	external(queuelen/1, "p_queuelen"),
	external(rad2deg/2, "p_rad2deg"),
	external(recovery/1, "p_recovery"),
	external(referee/1, "p_referee"),
	external(refresh/0, "p_refresh"),
	external(roboclock/1, "p_roboclock"),
	external(say/1, "p_say"),
	external(says/1, "p_says"),
	external(self/3, "p_self_dep"),
	external(self/5, "p_self"),
	external(sense_body/0, "p_sense_body_0"),
	external(sense_body/9, "p_sense_body_9"),
	external(simstep/1, "p_simstep"),
	external(speed/1, "p_speed"),
	external(stamina/1, "p_stamina"),
	external(start_viewserver/1, "p_start_viewserver"),
	external(stop/0, "p_stop"),
	external(stop_viewserver/0, "p_stop_viewserver"),
	external(succ_quality/2, "p_succ_quality"),
	external(teamname/2, "p_teamname"),
	external(turn/1, "p_turn"),
	external(turn_neck/1, "p_turn_neck"),
	external(turn_necks/1, "p_turn_necks"),
	external(turns/1, "p_turns"),
	external(uniformnumber/1, "p_uniformnumber"),
	external(view/1, "p_view_1"),
	external(view/2, "p_view_2"),
	external(wait_for_robo/0, "p_wait_for_robo"),
	external(wait_for_robo3/0, "p_wait_for_robo3").

%% self/4 (only body angle)
self(Time,X,Y,Angle) :-
	self(Time,X,Y,Angle,_).

%% user predicate object/11
object(Time, ball, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_ball(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).
object(Time, goal, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_goal(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).
object(Time, partner, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_partner(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).
object(Time, opponent, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_opponent(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).
object(Time, player, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_player(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).
object(Time, flag, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_flag(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).
object(Time, line, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_line(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).


%% user predicates for objects on the field
%% ball/10 flag/10 goal/10 line/10 partner/10 opponent/10 player/10
ball(Time, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_ball(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).

flag(Time, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_flag(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).

goal(Time, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_goal(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).


line(Time, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_line(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).

partner(Time, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_partner(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).

opponent(Time, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_opponent(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).

player(Time, Id, Dist, Dir, DDist, DDir, X, Y, BDir, FDir) :-
	b_player(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, BDir, FDir), 1).

%% for compatibility to "old" predicates. do not use in new programs, please.
%% these will not appear in future versions!
%% ball/6 goal/6 player/7 partner/7 opponent/7
ball(Dist, Dir, DDist, DDir, X, Y) :-
	b_ball(0, pos(Dist, Dir, DDist, DDir, X, Y, _BDir, _FDir), 1).
goal(Side, Dist, Dir, X, Y, 14.64) :-
	b_goal(Side, pos(Dist, Dir, _DDist, _DDir, X, Y, _BDir, _FDir), 1).
player(Nr, Dist, Dir, DDist, DDir, X, Y) :-
	b_player(Nr, pos(Dist, Dir, DDist, DDir, X, Y, _BDir, _FDir), 1).
partner(Nr, Dist, Dir, DDist, DDir, X, Y) :-
	b_partner(Nr, pos(Dist, Dir, DDist, DDir, X, Y, _BDir, _FDir), 1).
opponent(Nr, Dist, Dir, DDist, DDir, X, Y) :-
	b_opponent(Nr, pos(Dist, Dir, DDist, DDir, X, Y, _BDir, _FDir), 1).


%% objects shortcuts
object_xy(Time, Name, Id, X, Y) :-
	object(Time, Name, Id, _Dist, _Dir, _DDist, _DDir, X, Y, _BDir, _FDir).
object_dist(Time, Name, Id, Dist, Dir) :-
	object(Time, Name, Id, Dist, Dir, _DDist, _DDir, _X, _Y, _BDir, _FDir).
object_ddist(Time, Name, Id, DDist, DDir) :-
	object(Time, Name, Id, _Dist, _Dir, DDist, DDir, _X, _Y, _BDir, _FDir).
object_face(Time, Name, Id, BDir, FDir) :-
	object(Time, Name, Id, _Dist, _Dir, _DDist, _DDir, _X, _Y, BDir, FDir).

ball_xy(Time, X, Y) :-
	b_ball(Time, 0, pos(_Dist, _Dir, _DDist, _DDir, X, Y, _BDir, _FDir), 1).
ball_dist(Time, Dist, Dir) :-
	b_ball(Time, 0, pos(Dist, Dir, _DDist, _DDir, _X, _Y, _BDir, _FDir), 1).
ball_ddist(Time, DDist, DDir) :-
	b_ball(Time, 0, pos(_Dist, _Dir, DDist, DDir, _X, _Y, _BDir, _FDir), 1).

goal_xy(Time, Id, X, Y) :-
	b_goal(Time, Id, pos(_Dist, _Dir, _DDist, _DDir, X, Y, _BDir, _FDir), 1).
goal_dist(Time, Id, Dist, Dir) :-
	b_goal(Time, Id, pos(Dist, Dir, _DDist, _DDir, _X, _Y, _BDir, _FDir), 1).
goal_ddist(Time, Id, DDist, DDir) :-
	b_goal(Time, Id, pos(_Dist, _Dir, DDist, DDir, _X, _Y, _BDir, _FDir), 1).

flag_xy(Time, Id, X, Y) :-
	b_flag(Time, Id, pos(_Dist, _Dir, _DDist, _DDir, X, Y, _BDir, _FDir), 1).
flag_dist(Time, Id, Dist, Dir) :-
	b_flag(Time, Id, pos(Dist, Dir, _DDist, _DDir, _X, _Y, _BDir, _FDir), 1).
flag_ddist(Time, Id, DDist, DDir) :-
	b_flag(Time, Id, pos(_Dist, _Dir, DDist, DDir, _X, _Y, _BDir, _FDir), 1).

line_xy(Time, Id, X, Y) :-
	b_line(Time, Id, pos(_Dist, _Dir, _DDist, _DDir, X, Y, _BDir, _FDir), 1).
line_dist(Time, Id, Dist, Dir) :-
	b_line(Time, Id, pos(Dist, Dir, _DDist, _DDir, _X, _Y, _BDir, _FDir), 1).
line_ddist(Time, Id, DDist, DDir) :-
	b_line(Time, Id, pos(_Dist, _Dir, DDist, DDir, _X, _Y, _BDir, _FDir), 1).

player_xy(Time, Id, X, Y) :-
	b_player(Time, Id, pos(_Dist, _Dir, _DDist, _DDir, X, Y, _BDir, _FDir), 1).
player_dist(Time, Id, Dist, Dir) :-
	b_player(Time, Id, pos(Dist, Dir, _DDist, _DDir, _X, _Y, _BDir, _FDir), 1).
player_ddist(Time, Id, DDist, DDir) :-
	b_player(Time, Id, pos(_Dist, _Dir, DDist, DDir, _X, _Y, _BDir, _FDir), 1).
player_face(Time, Id, BDir, FDir) :-
	b_player(Time, Id, pos(_Dist,_Dir,_DDist,_DDir,_X,_Y, BDir,FDir), 1).

partner_xy(Time, Id, X, Y) :-
	b_partner(Time, Id, pos(_Dist, _Dir, _DDist, _DDir, X, Y, _BDir, _FDir), 1).
partner_dist(Time, Id, Dist, Dir) :-
	b_partner(Time, Id, pos(Dist, Dir, _DDist, _DDir, _X, _Y, _BDir, _FDir), 1).
partner_ddist(Time, Id, DDist, DDir) :-
	b_partner(Time, Id, pos(_Dist, _Dir, DDist, DDir, _X, _Y, _BDir, _FDir), 1).
partner_face(Time, Id, BDir, FDir) :-
	b_partner(Time, Id, pos(_Dist,_Dir,_DDist,_DDir,_X,_Y, BDir,FDir), 1).

opponent_xy(Time, Id, X, Y) :-
	b_opponent(Time, Id, pos(_Dist, _Dir, _DDist, _DDir, X, Y, _BDir, _FDir), 1).
opponent_dist(Time, Id, Dist, Dir) :-
	b_opponent(Time, Id, pos(Dist, Dir, _DDist, _DDir, _X, _Y, _BDir, _FDir), 1).
opponent_ddist(Time, Id, DDist, DDir) :-
	b_opponent(Time, Id, pos(_Dist, _Dir, DDist, DDir, _X, _Y, _BDir, _FDir), 1).
opponent_face(Time, Id, BDir, FDir) :-
	b_opponent(Time, Id, pos(_Dist,_Dir,_DDist,_DDir,_X,_Y, BDir,FDir), 1).
	

%% compatibility predicate object/10
object(Time, Name, Id, Dist, Dir, DDist, DDir, X, Y, FDir) :-
	object(Time, Name, Id, Dist, Dir, DDist, DDir, X, Y, _, FDir).
%% compatibility ball/9,flag/9,line/9,opponent/9,partner/9,player/9
ball(Time, Id, Dist, Dir, DDist, DDir, X, Y, FDir) :-
	b_ball(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, _, FDir), 1).
flag(Time, Id, Dist, Dir, DDist, DDir, X, Y, FDir) :-
	b_flag(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, _, FDir), 1).
line(Time, Id, Dist, Dir, DDist, DDir, X, Y, FDir) :-
	b_line(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, _, FDir), 1).
goal(Time, Id, Dist, Dir, DDist, DDir, X, Y, FDir) :-
	b_goal(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, _, FDir), 1).
opponent(Time, Id, Dist, Dir, DDist, DDir, X, Y, FDir) :-
	b_opponent(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, _, FDir), 1).
partner(Time, Id, Dist, Dir, DDist, DDir, X, Y, FDir) :-
	b_partner(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, _, FDir), 1).
player(Time, Id, Dist, Dir, DDist, DDir, X, Y, FDir) :-
	b_player(Time, Id, pos(Dist, Dir, DDist, DDir, X, Y, _, FDir), 1).


start_viewserver :-
	start_viewserver(7000).

open_log(Logfile, App) :-
	open_log(Logfile, App, 50).

open_log(Logfile) :-
	open_log(Logfile, false).

open_audiolog(Logfile, App) :-
	open_audiolog(Logfile, App, 50).

open_audiolog(Logfile) :-
	open_audiolog(Logfile, false).




init(player, Name, Server, Port, Version) :-
	init_player(Name, Server, Port, Version).

init(goalie, Name, Server, Port, Version) :-
	init_goalie(Name, Server, Port, Version).

init(Player, Name, Server, Port) :-
	init(Player, Name, Server, Port, 5.0).

init(Player, Name, Server) :-
	init(Player, Name, Server, 6000).

init(Player, Name) :-
	init(Player, Name, "localhost").
