/* -*- mode: c++ -*-
   
   this file is part of the robolog libraries
   locate nonmovable objects on the soccer field
   Copyright (C) Oct 21 1997 Oliver Obst
   $Id: sfield.h,v 1.3 1999/02/03 07:27:12 frvit Exp $

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
#ifndef _SFIELD_H
#define _SFIELD_H

#include "soccerconst.h"
#include "maths.h"
#include "objarray.h"
#include "objinfo.h"
#include "knowledge.h"

class Sfield
{
public:
        Sfield(Knowledge *k0);
        virtual ~Sfield();

        Cvector getpos(ObjInfo &obj);
        double  xsize(ObjInfo &obj);
        double  ysize(ObjInfo &obj);

private:
        position getobj(ObjInfo &obj);

private:        
        Knowledge *k;
        
};

#endif
