/* -*- mode: c++ -*-
   this file is part of the robolog libraries
   simple robot actions
   Copyright (c) Apr 09 1998 Oliver Obst
   $Id: simple.h,v 1.4 1999/05/05 14:41:25 frvit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _SIMPLE_H
#define _SIMPLE_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "control.h"
#include "listproc.h"
#include "fifo.h"
#include "self.h"

class Simple : public Control
{
public:
        Simple(Self *s, Listproc *l, Knowledge *k0,
               const char *server, int port, double ver);
        virtual ~Simple();

        void    normal_init(const char *teamname=0);
        void    goalie_init(const char *teamname=0);

        void    moveto(double x, double y);
        void    turn(double moment);
        void    turn_neck(double angled);
        void    dash(double power);
        void    kick(double power, double direction);
        void    say(const char *text);

private:
        Self *self;
        Knowledge *k;
};

#endif /* _SIMPLE_H */
