/* -*- mode: c++ -*-
   this file is part of the robolog libraries
   a robot timer
   Copyright (C) Apr 06 1999 Oliver Obst
   $Id: timer.h,v 1.1 1999/05/05 15:02:38 frvit Exp $
   
 * most of the stuff in this file is taken from or based upon
 * CMUnited98 (soccer client for Robocup98)
 * Peter Stone <pstone@cs.cmu.edu>
 * Computer Science Department
 * Carnegie Mellon University
 * Copyright (C) 1998 Peter Stone
 *
 * CMUnited-98 was created by Peter Stone, Manuela Veloso, and Patrick Riley
 *
 * You may copy and distribute this program freely as long as you retain
 * this notice.
 * If you make any changes or have any comments we would appreciate a message.
 *
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef TIMER_H
#define TIMER_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

class Timer
{
public:
        Timer(int vt = 0, int vs = 0);

        Timer operator =(const int &a) { t = a; s = 0; return *this; }

        int operator ==(const Timer &a) { return (s == a.s) && (t == a.t); }
        int operator ==(const int &a)   { return t == a; }
        int operator !=(const Timer &a) { return (s != a.s) || (t != a.t); }
        int operator !=(const int &a)   { return t != a; }
        int operator < (const Timer &a) { return (t < a.t)
                                                  || (t == a.t && s < a.s); }
        int operator < (const int &a)   { return t < a; }
        int operator <=(const Timer &a) { return (t < a.t)
                                                  || (t == a.t && s <= a.s); }
        int operator <=(const int &a)   { return t <= a; }
        int operator > (const Timer &a) { return (t > a.t)
                                                  || (t == a.t && s > a.s); }
        int operator > (const int &a)   { return t > a; }
        int operator >=(const Timer &a) { return (t > a.t)
                                                  || (t == a.t && s >= a.s); }
        int operator >=(const int &a)   { return t >= a; }
        int operator !()                { return (s == 0) && (t == 0); }

        Timer operator -(const int &a);
        Timer operator +(const int &a);

        int  operator -(const Timer &a);        

        void operator -=(const int &a) { *this = *this - a; }
        void operator -=(const Timer &a){ *this = *this - a; }
        void operator +=(const int &a) { *this = *this + a; }
        void operator ++()             { *this += 1; }
        void operator --()             { *this -= 1; }

        int t; /* time from the server */
        int s; /* stopped clock cycles */
};
#endif
